<?php
namespace Ecommerce\Controllers;

use Zeedhi\Framework\Report\ReportService;
use Zeedhi\Framework\DTO;

class TestConfigurationController extends \Zeedhi\Framework\Controller\Report
{
    protected $birtStrategy;
    protected $reportService;
    protected $QR2Strategy;
    protected $smtpUtil;
    protected $environment;
    
    public function __construct($reportService, $birtStrategy, $QR2Strategy, $smtpUtil, $environment) {
        $this->reportService     = $reportService;
        $this->birtStrategy      = $birtStrategy;
        $this->QR2Strategy       = $QR2Strategy;
        $this->smtpUtil          = $smtpUtil;
        $this->environment       = $environment;
    }
    
    /** @var array */
    protected $reportMapping = array (
        'testConfiguration' =>
            array (
                'strategy' => 'BIRT',
                'parameterMapping' =>
                    array ("NRORG" => "NRORG")
            ),
        'GER01300' =>
            array (
                'strategy' => 'QR2',
                'parameterMapping' =>
                    array ()
            )
    );
    
    public function beforeProcessReport(DTO\Request\Row $request, DTO\Response $response) {
        $row = $request->getRow();

        $qr2type = isset($row['QR2TYPE']) ? $row['QR2TYPE'] : 'PDF';
        $row['NRORG'] = $this->environment->getNrorgTrab();

        $this->birtStrategy->setReportFormat($qr2type);
        $this->QR2Strategy->setQr2Type($qr2type);
    }
    
    public function testConfiguration(DTO\Request\Row $request, DTO\Response $response) {
        
        $row = $request->getRow();
        
        if($row['action'] == 'sendMail') {
            self::sendMail($row);
        } else {
            parent::createRemoteReport($request, $response);
        }
        
    }
    
    public function sendMail($row) {
        
        $address = $row['mailTo'];
        $message = 'TEST PHPMailer';
        
        $this->smtpUtil->sendMail($message, $address);
        
    }
    
}